var tutorial = document.getElementById("tutorial");
var informations = document.getElementById("informations");
var message = document.getElementById("message");

var ecran_action = document.getElementById("ecran_action");
var ecran_heure = document.getElementById("ecran_heure");
var ecran_etat = document.getElementById("ecran_etat");
var ecran_description = document.getElementById("ecran_description");

var icone_plante = document.getElementById("icone_plante");
var icone_plante_index = 0;

var actions = [];
var actions_index_actuel = 0;

function Interface(theme, min, max, temps, couleurMin, couleurMax, etat, description){
	this.theme = theme;
	this.min = min;
	this.max = max;
	this.valeur = 1;
	this.temps = temps;
	this.couleurMin = couleurMin;
	this.couleurMax = couleurMax;
	this.etat = etat;	//du moins bon jusqu'au plus optimisé
	this.description = description; //description des états
	actions.push(this);
}

//écran de veille ?
var action_eau = new Interface("Eau", 0, 100, 1, [0, 0, 255], [0, 0, 255], ["Sec", "Manque d'eau", "Normal", "Bon"], ["La plante a besoin d'être arrosée !", "La plante commence à avoir soif !", "Le niveau d'eau est normal.", "La plante a assez d'eau."]);
var action_lumiere = new Interface("Lumière", 0, 10, 24, [50, 10, 150], [255, 255, 230], ["Pas de lumière", "Sombre", "Normal", "Bon"], ["La plante a besoin de lumière !", "La plante manque de lumière.", "La luminosité est normale.", "La plante a assez de lumière."]);
var action_temperature = new Interface("Température", 15, 25, 10, [50, 50, 255], [200, 0, 0], ["Froid", "Frais", "Normal", "Bon"], ["Il fait froid, la plante a besoin de chaleur !", "La température est fraîche pour la plante.", "La température convient à la plante.", "La température est parfaite pour la plante."]);
var action_plante = new Interface("Info Plante", 0, 3, 0, [0, 200, 0], [0, 200, 0], ["Tomate", "Fraise", "Salade"], ["La tomate est un légume rond et rouge. Elle a besoin de chaleur et de beaucoup d'eau.", "La fraise est un petit fruit rouge, très gourmand en eau, surtout en cas de fortes chaleurs.", "La salade est une petite plante feuillue, qui a besoin d'être régulièrement arrosée.", "La température est parfaite pour la plante."]);

var actions_index_max = actions.length;
var icone_plante_max = action_plante.etat.length;

var jauge = document.getElementById("jauge");
var jauge_entiere = document.getElementById("jauge_entiere");

switch_action(actions[0]);
icone_plante.style.backgroundImage = "url('./data/textures/" + action_plante.etat[icone_plante_index] + ".png')";

var bouton_pause = document.getElementById("bouton_pause");

var frequence = 200; //ms
var temps_message = 0;
var intervale;
var simulation_pause = false; //0 = simulation en cours, 1 = pause
var date = 6;

var multiplicateur_temps = document.getElementById("multiplicateur_temps");
var vitesse_temps = document.getElementById("vitesse_temps");
vitesse_temps.innerHTML = multiplicateur_temps.value;
var coef_temps = 1;
vitesse_temps.innerHTML = "x" + String(coef_temps);

multiplicateur_temps.oninput = function() {
	coef_temps = this.value;
	vitesse_temps.innerHTML = "x" + String(coef_temps);
}

var doit_intervenir = false;

ecran_heure.innerHTML = date_str();	//init

function change_action_index(index){
	if (index == -1 && actions_index_actuel > 0) actions_index_actuel--;
	else if (index == 1 && actions_index_actuel < actions_index_max - 1) actions_index_actuel++;
	switch_action(actions[actions_index_actuel]);
}

function change_index_icone_plante(){
	if (icone_plante_index == icone_plante_max - 1) icone_plante_index = 0;
	else icone_plante_index++;
	icone_plante.style.backgroundImage = "url('./data/textures/" + action_plante.etat[icone_plante_index] + ".png')";
	//force d'actualiser le nom de la plante et sa description au cas où la simulation est en pause.
	ecran_description.innerHTML = "Description : " + action_plante.description[icone_plante_index];
	ecran_etat.innerHTML = "Plante : " + action_plante.etat[icone_plante_index];
}

function valider_action(){
	if (action_plante == actions[actions_index_actuel]) change_index_icone_plante();	//si l'utilisateur veut changer de plante
	else if (action_eau == actions[actions_index_actuel] && action_eau.valeur != 1){
		affiche_message("Vous venez d'arroser la plante !");
		action_eau.valeur = 1; 		//arrosage manuel
		jauge.style.height = String(90 * action_eau.valeur) + "%";		//force la jauge à s'actualiser au cas où la simulation serait en pause
	}
}

function affiche_message(string){
	message.innerHTML = string;
}

function date_str(){
	var heures = Math.floor(date);
	var minutes = Math.floor((date - heures) * 60);
	var string;
	if (minutes < 10) string = String(heures) + "h0" + String(minutes); 
	else string = String(heures) + "h" + String(minutes);
	if (date > 8 && date < 20)string += " ☼";
	else string += " ☽";
	if (doit_intervenir){
		string += " ⚠";	// symbole attention
	}
	return string;
}

function switch_action(action){
	if (action == action_plante){
		icone_plante.style.display = "block";
		jauge_entiere.style.display = "none";
	}
	else {
		icone_plante.style.display = "none";
		jauge_entiere.style.display = "flex";
	}
	actualise_jauge(action);
}

function pause_simulation(){
	if (simulation_pause){
		intervale = setInterval(animate, frequence);
		bouton_pause.innerHTML = "►";
	}
	else {
		clearInterval(intervale);
		bouton_pause.innerHTML = "||";
	}
	simulation_pause = !simulation_pause;
}

function open_tutorial(){	
	tutorial.style.display = "block";
}

function close_tutorial(){
	tutorial.style.display = "none";
}

function open_info(){	
	informations.style.display = "block";
}

function close_info(){
	informations.style.display = "none";
}

//boucles

function animate(){
	check_action();
	action_eau.valeur -= 0.00035 * (action_lumiere.valeur + action_temperature.valeur) * coef_temps;	//plus il fait chaud, plus il y a de soleil plus la plante a soif + taille de la plante ?
	if (action_eau.valeur < 0.001){
		affiche_message("La plante vient d'être arrosée.");
		action_eau.valeur = 1;	//la jardinière s'arrose automatiquement si le niveau d'eau est critique
	}
	actualise_jauge(actions[actions_index_actuel]);
	cycle_jour();
	if (message.innerHTML != "" && temps_message < 5000){
		temps_message += frequence;	// la boucle est exécutée toutes les 200ms
	}
	else {
		temps_message = 0;	//on rénitialise le timer et on efface le message
		message.innerHTML = "";
	}
}

function actualise_jauge(action){
	ecran_action.innerHTML = action.theme;
	var index_etat = action.valeur == 1 ? action.etat.length - 1 : Math.floor(action.valeur * action.etat.length);
	
	if (actions[actions_index_actuel] != action_plante){
		ecran_description.innerHTML = "Description : " + action.description[index_etat];
		ecran_etat.innerHTML = "Etat : " + action.etat[index_etat];
	}
	else {
		ecran_description.innerHTML = "Description : " + action_plante.description[icone_plante_index];		//si on est sur l'interface plante on affiche la description de la plante
		ecran_etat.innerHTML = "Plante : " + action.etat[icone_plante_index];
	}
	
	if (action.theme == "Eau") jauge.style.backgroundColor = "rgb(" + action.couleurMax[0] + "," + action.couleurMax[1] + "," + action.couleurMax[2] + ")";
	else jauge.style.backgroundColor = "rgb(" + (action.couleurMin[0] + (action.couleurMax[0] - action.couleurMin[0]) * action.valeur)
		+ "," + (action.couleurMin[1] + (action.couleurMax[1] - action.couleurMin[1]) * action.valeur)
		+ "," + (action.couleurMin[2] + (action.couleurMax[2] - action.couleurMin[2]) * action.valeur) + ")";
	jauge.style.height = String(90 * action.valeur) + "%";
}

function cycle_jour(){
	date += 0.01 * coef_temps;	//vitesse à laquelle le jour passe
	date %= 24;		//24h = 0h
	ecran_heure.innerHTML = date_str();
	action_lumiere.valeur = Math.exp(-Math.pow((0.19 * (date - 14)),4));
}

function check_action(){	//check si la plante a besoin de quelque chose
	// if (action_eau.valeur > 0.33 && action_lumiere.valeur > 0.5) doit_intervenir = false;
	if (action_eau.valeur > 0.33) doit_intervenir = false;	//ajouter à l'avenir la température, la lumière s'il en manque en journée
	else doit_intervenir = true;
}